//+------------------------------------------------------------------+
//|                                                 MTF_ZLSTCHV3.mq4 |
//|  mtf ForexTSD keris ki        based on: Modified for mtf by SIMBA|
//|           v3m - 3/2colorStoch display swich                                                       |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Everybody"

#property indicator_separate_window
//---- indicator settings
#property indicator_buffers 4
#property indicator_color1 Yellow     
#property indicator_color2 Lime
#property indicator_color3 Red
#property indicator_color4 Magenta 

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2

#property indicator_level1 80
#property indicator_level2 50
#property indicator_level3 20
#property indicator_levelcolor DarkSlateBlue
#property indicator_levelstyle 4

#property indicator_maximum 100
#property indicator_minimum 0

//---- indicator parameters

extern int  TimeFrame      = 0;
extern int  CountBars      = 3000;
extern bool Stoch3ColorDisplay  = false;
extern string  note_ZlgSth = "f-la based on stok1stok2stok3stok4stok5";
extern string  TimeFrames  = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";


//---- indicator buffers
double      ind_buffer1[];
double      ind_buffer2[];
double      ind_buffer3[];
double      ind_buffer4[];

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
**************************************************************************/
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   IndicatorBuffers(4);
//---- indicator buffers mapping
  SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ind_buffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ind_buffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ind_buffer3);
    SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ind_buffer4);
  
 SetIndexLabel(0,"MTF_ZLagSth K");
 SetIndexLabel(1,"");
// SetIndexLabel(2,""); 
 SetIndexLabel(2,"MTF_ZLagSth D");

//---- name for DataWindow and indicator subwindow label   
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="H4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN1"; break;
      default : TimeFrameStr="CurrentTF";
   } 
   IndicatorShortName("ZLSTCH V3  [" + TimeFrameStr + "]  ");
  }
//----
   return(0);
 
int start()
  {
   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted();
    
// Plot defined timeframe on to current timeframe   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
  
limit= Bars-counted_bars;
limit= MathMax(limit,TimeFrame/Period());
limit= MathMin(limit,CountBars);
  
   for(i=0,y=0;i<limit;i++)
   {
   if (TimeFrame<Period())TimeFrame=Period();
   if (Time[i]<TimeArray[y]) y++; 
   
 /***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator timeframe
   Rule 3:  Use 'y' for the indicator's shift value
 **********************************************************/  
if (Stoch3ColorDisplay)
  {   
   ind_buffer1[i]=iCustom(NULL,TimeFrame,"Zerolagstochs_v3",false,0,y);
   ind_buffer2[i]=iCustom(NULL,TimeFrame,"Zerolagstochs_v3",false,1,y);
   ind_buffer3[i]=iCustom(NULL,TimeFrame,"Zerolagstochs_v3",false,2,y);
   ind_buffer4[i]=iCustom(NULL,TimeFrame,"Zerolagstochs_v3",false,3,y);
   }
else
   ind_buffer2[i]=iCustom(NULL,TimeFrame,"Zerolagstochs_v3",false,0,y);
   ind_buffer3[i]=iCustom(NULL,TimeFrame,"Zerolagstochs_v3",false,2,y);
   ind_buffer4[i]=iCustom(NULL,TimeFrame,"Zerolagstochs_v3",false,3,y);

   }  
     

//+++++++++++++++++++++++++++++++++++++++++++++++++ SIMBA
   if (TimeFrame>Period()) {
     int PerINT=TimeFrame/Period()+1;
     datetime TimeArr[]; ArrayResize(TimeArr,PerINT);
     ArrayCopySeries(TimeArr,MODE_TIME,Symbol(),Period()); 
     for(i=0;i<PerINT+1;i++) {if (TimeArr[i]>=TimeArray[0]) {
//----
 /************************************************       
    Refresh buffers:         buffer[i] = buffer[0];
 ********************************************************/  
   ind_buffer1[i]=ind_buffer1[0];
   ind_buffer2[i]=ind_buffer2[0];
   ind_buffer3[i]=ind_buffer3[0];
   ind_buffer4[i]=ind_buffer4[0];

//----
   } } }
//+++++++++++++++++++++++++++++++++++++++++++++++  Raff


   return(0);
  }
//+------------------------------------------------------------------+